import json

import click
import requests
from tqdm import tqdm

import scripts.paths

END_POINT = "https://api.llmhub.infs.ch/embedding"
LLM_MODEL = "intfloat/multilingual-e5-large-instruct"
DESCRIPTION = {
    "description": f"embeddings generated by {END_POINT}"
}

def embed_spatial_entities(api_key):
    changes_in_entities = False

    entity_embedding_dict = load_entity_embedding_json()
    spacial_entities = load_spatial_entities()

    print("Embedding:")
    for entity in tqdm(spacial_entities['data']):
        for lang in ["name_en", "name_de", "name_fr"]:
            for name in entity[lang]:
                if name not in entity_embedding_dict:
                    changes_in_entities = True
                    embedding = request_embedding(name, api_key)
                    entity_embedding_dict[name] = embedding

    if changes_in_entities:
        create_entity_embedding_json(entity_embedding_dict)

def request_embedding(text, api_key):
    task_description = "Embed the given text using the best-suited language."
    payload = {
        "model": "intfloat/multilingual-e5-large-instruct", 
        "text": f"Instruct: {task_description}\nQuery: {text}"
    }
    headers = {
        'LLMHUB-API-KEY': f"{api_key}",
        'Content-Type': "application/json"
    }

    response = requests.post(END_POINT, json=payload, headers=headers).json()
    try:
        return response["embedding"]
    except Exception as e:
        print("While requesting", e)
        return None

def create_entity_embedding_json(entity_embedding_dict):
    path = scripts.paths.EMBEDDINGS_FILE

    data_with_description = {
        "_llm_url": END_POINT,
        "_llm_model": LLM_MODEL,
        "entity_embeddings": entity_embedding_dict
    }

    with open(path, 'w', encoding='utf-8') as file:
        json.dump(data_with_description, file, ensure_ascii=False)


def load_entity_embedding_json():
    path = scripts.paths.EMBEDDINGS_FILE

    try:
        with open(path, 'r', encoding='utf-8') as file:
            data = json.load(file)["entity_embeddings"]
    except FileNotFoundError:
        data = {}
    return data


def load_spatial_entities():
    with open(scripts.paths.ENTITIES_FILE, 'r', encoding='utf-8') as file:
        data = json.load(file)
    return data
